#!/usr/bin/python -u
import zlib
import sys
import time
import os
import pwd

from Crypto import Random
from Crypto.Cipher import AES


def gen_rand_bytes(n):
	return Random.new().read(n)


secret_file = sys.argv[1]
f = open(secret_file, "r")
secret = f.read().strip()


key = secret

key = key[:16]



def pad_string(s, block_size):
	l = len(s)
	pad_len = ((l / block_size ) + 1) * block_size
	return s + chr(pad_len-l) * (pad_len-l)


def get_block(s, ith, block_size):
	return s[ith * block_size : (ith + 1) * (block_size)]

def rawstr_xor(s1, s2):
	xored = []
	for i in range(len(s1)):
		xored.append(chr(ord(s1[i]) ^ ord(s2[i])))

	return ''.join(xored)


def ecb_encrypt_block(plainblock, key):
	if len(plainblock) != 16:
		print "only 16 byte blocks can be encrypted. This block has %d bytes" % (len(plainblock),)
		raise Exception

	aes = AES.new(key, AES.MODE_ECB)
	raw_s = aes.encrypt(plainblock)
	return raw_s

def ecb_encrypt_plain(plaintext, key):
	plaintext = pad_string(plaintext,16)
	cipher = []
	for i in range(0,len(plaintext)/16):
		cipher.append( ecb_encrypt_block( get_block(plaintext,i,16), key) )
	return ''.join(cipher)


def crystal_ball_veil(hint):
	prefix = secret
	body = hint
	suffix = secret

	return ecb_encrypt_plain(prefix + body + suffix, key)
	


def check_secret():
	global secret
	print "-I already know the secret. It is 42, of course, right?"
	user_secret = raw_input()
	if user_secret == secret:
		print "-The Gods have spoken"
		with open(sys.argv[1], 'rt') as f:
			flag = f.read().strip()
		print "-The flag is %s" % flag
		exit(0)
	else:
		exit(42)

def get_reading():
	print "-Yes, I can see it now. What exactly am I seeing???"
	hint = raw_input()
	print "Ah, yes! %s... Of course!" % hint
	print "Crystal ball, crystal ball. Show this human his destiny:"
	destiny = crystal_ball_veil(hint)
	print destiny.encode('hex')
	print "[thundering sounds]"


if __name__ == "__main__":
	print "The ancient seer will see you now:"

	while True:
		print "-What is it kid? Speak up!"
		print "Your action:"
		print "1. Try telling him the secret"
		print "2. Ask for a reading in the crystal ball"
		option = raw_input()
		if option == "1":
			check_secret()
		elif option == "2":
			get_reading()
		else:
			print "Not implemented"
